CONTENTS OF THIS FILE
---------------------
   
 * Introduction
 * Requirements
 * Installation
 * Configuration
 * Misc
 * Goals & Features
 * Documentation
 * Learning resources
 * Maintainers


INTRODUCTION
------------

Base theme with a goal to support full frontend Drupal theme development
workflow from start to finish.


REQUIREMENTS
------------

This theme has no additional requirements.


INSTALLATION
------------
 
 * Install as you would normally install a contributed Drupal theme. See:
   https://www.drupal.org/docs/8/extending-drupal-8/installing-themes for further information.


CONFIGURATION
-------------

The theme has no custom or new modifiable settings.


Goals & Features
----------------

- Developer oriented - no tons of UI settings or big assumptions.
- Presents and use good development workflow for building themes.
- Light weight.
- BEM oriented.
- Implements bs_bootstrap Bootstrap 4 based child theme.
- Gulp build process.
- Semantically clean HTML as much as possible - use mixins and don't hardcode
  CSS framework classes where it does not make sense.
- Explore all new nice&cool stuff that is supported in major browsers.
- Ideally everything should be easy to override.
  Stay flexible and let child theme developers to do what they want how they
  want. Ideally we are just offering standardized workflow and are letting child
  theme developer to reuse everything or just parts.
- Use just the APIs that exist in Drupal core, do not invent new APIs.


Documentation
-------------

### Install

We need some global dependencies: node, npm, and gulp-cli.
For debian based system check https://nodejs.org/en/download/package-manager/#debian-and-ubuntu-based-linux-distributions.

To install Node.js 4.x version and the rest of global dependencies
commands are basically:

```
$ curl -sL https://deb.nodesource.com/setup_4.x | sudo -E bash -
$ sudo apt-get install -y nodejs
$ npm install -g gulp-cli
```

When all dependencies are installed do:

```
$ npm install
```


### Standard stuff

Build CSS with 

```
$ gulp sass
```

Use watch task if you like

```
$ gulp watch
```

Just build everything for production

```
$ gulp
```

Specific Gulp task we currently offers are:

- gulp sass
- gulp sass:dev
- gulp sass:lint
- gulp clean:css

Additionaly bs_bootstrap child theme offers next two tasks:

- gulp bootstrap:js
- gulp bootstrap:js:dev
- gulp clean:bootstrap

Watchers:

- gulp watch
- gulp watch-dev

Run all tasks:

- gulp
- gulp prod
- gulp dev


### gulp-options.json

Various config variables we use for gulp build. Do note that if paths
are relative they are relative from position of gulpfile.js.


### Browser support explained

```js
browsersSupport: [
    // For all good platforms we support only last two browser versions.
    'last 2 versions',
    // For now we do IE10+.
    'ie >= 10',
    // iOS 7 and 8 supports flexbox with prefixes, so to support iPhone 5 we need
    // to add this.
    'Safari >= 7'
]
```


Learning resources
------------------

- https://github.com/Famolus/awesome-sass
  Curated list of awesome Sass and SCSS frameworks, libraries, style guides,
  articles, and resources.


MAINTAINERS
-----------

Current maintainers:
 * Ivica Puljic (pivica) - https://www.drupal.org/u/pivica
 
This project has been sponsored by:
 * ACTO Team - https://www.drupal.org/acto-team
   Drupal development, design and support company.
 * MD Systems - https://www.drupal.org/md-systems
   Drupal core and contributed development.  
   MD Systems is working for small start-ups as well as large Swiss corporations
   with international, multilingual websites.

